/* Define constants for communication with parse.y.
   Copyright (C) 1987 Free Software Foundation, Inc.
   Copyright (C) 1989, 1990 Apple Computer, Inc.

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 1, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */



enum rid
{
  RID_UNUSED,
  RID_INT,
  RID_CHAR,
  RID_FLOAT,
  RID_DOUBLE,
  RID_VOID,
  RID_UNUSED1,
#ifdef APPLE_C
  /* RIDs for new Apple type names. */
  RID_COMP,
  RID_EXTENDED,
#endif /* APPLE_C */

  RID_UNSIGNED,
  RID_SHORT,
  RID_LONG,
  RID_AUTO,
  RID_STATIC,
  RID_EXTERN,
  RID_REGISTER,
  RID_TYPEDEF,
  RID_SIGNED,
  RID_CONST,
  RID_VOLATILE,
  RID_INLINE,
  RID_NOALIAS,
#ifdef APPLE_C
  /* The `pascal' keyword in Apple C. */
  RID_PASCAL,
#endif /* APPLE_C */

  RID_MAX
#ifdef MPW_C31
  /* Make sure the enum is int-sized. */
  ,rid_intifier = 1000000
#endif /* MPW_C31 */
};

#define RID_FIRST_MODIFIER RID_UNSIGNED
