/* Configuration for GNU C-compiler for random 32-bit-int machines
   cross-compiling to Macintosh MPW.
   Copyright (C) 1988 Free Software Foundation, Inc.
   Copyright (C) 1989, 1990 Apple Computer, Inc.

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 1, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* The oddities of MPW C are unique to MPW. */
#ifdef MPW_C
#ifndef MPW_C31
#define MPW_C31
#endif
#ifndef MPW
#define MPW
#endif
#endif

/* Do mods for Apple's dialect of C. */

#ifndef APPLE_C
#define APPLE_C
#endif

/* This is for generic improvements to GCC. */

#define APPLE_HAX

/* This tweaks the preprocessor to like double slash as a comment. */

#define CPLUSPLUS

/* #defines that need visibility everywhere.  */
#define FALSE 0
#define TRUE 1

/* This describes the machine the compiler is hosted on.  */
#define HOST_BITS_PER_CHAR 8
#define HOST_BITS_PER_SHORT 16
#define HOST_BITS_PER_INT 32
#define HOST_BITS_PER_LONG 32

/* Arguments to use with `exit'.  */
#define SUCCESS_EXIT_CODE 0
#define FATAL_EXIT_CODE 33

/* target machine dependencies. */

#ifdef sparc
#include <alloca.h>
#endif

#include "tm.h"

/* MPW-specific hacks. */

#ifdef MPW

/* MPW C doesn't know about alloca. */
#ifndef __GNUC__
#define USE_C_ALLOCA
#else
#define alloca __builtin_alloca
#endif

/* Pick up the cursor-spinning magic. */
#include <CursorCtl.h>

/* Assorted redefinitions, from BSD-like to SysV/ANSI-like. */
#define bzero(a,b) memset(a,0,b)
#define bcopy(a,b,c) memcpy(b,a,c)
#define bcmp(a,b,c) memcmp(a,b,c)
#define index strchr

/* Fancy abort is a little more informative. */
#define abort() fancy_abort()

/* We want all newly created files to be type TEXT and creator 'MPS ', that is,
   MPW Shell docs that we can look at by double-clicking. */

/* Crude, but simpler than trying to modify all the gen* programs. */
#ifdef __STDIO__
FILE *mpw_fopen();
#endif

#define fopen(a,b) mpw_fopen(a,b)

#endif /* MPW */

