/******************************************************************************
 CBrowseResDoc.h

		
	SUPERCLASS = CDocument
	
	Copyright  1991 Symantec Corporation. All rights reserved.
				
	TCL 1.1.3 Changes
	[
		- use #pragma once
		- changed forward declarations to use CLASS
	]
 ******************************************************************************/

#pragma once

#include "CDocument.h"

CLASS CResTypePane;
CLASS CResBrowser;
CLASS CArray;

class CBrowseResDoc : public CDocument
{

public:

	void				IBrowseResDoc( CApplication *aSupervisor, Boolean printable);
	virtual void		NewFile(void);
	virtual void		OpenFile( SFReply *macSFReply);
	
	virtual void		DoCommand( long aCommand);
	
	virtual void 		RemoveDirector( CDirector *aDirector);
	virtual void 		AddType( Handle theHandle, ResType newtype, Str255 newname);
	virtual Boolean 	DoSave( void);
	virtual void		Dispose( void);

protected:

	CArray			*itsResTypes;	//	a list of all resource types in the document
	CResTypePane 	*itsTypePane;	//	the view displaying the resource types

	virtual Boolean		CanOpenType( ResType aResType);
	virtual void		BuildMainWindow( void);
	virtual void		BuildTypeList( void);
	
	virtual void		OpenTypeWindow( void);
	virtual CResBrowser	*MakeTypeBrowser( ResType aType);
	virtual CArray		*BuildResourceList( ResType aType);
};