/******************************************************************************
 CDRVRDirector.c

		
	SUPERCLASS = CDLOGDirector
	
	Copyright  1991 Symantec Corporation. All rights reserved.
	

 ******************************************************************************/

#include "CDRVRDirector.h"
#include <CScrollPane.h>
#include <CDialogText.h>
#include <CDialog.h>
#include <CPaneBorder.h>
#include <CApplication.h>
#include <CTextEnvirons.h>
#include <CIntegerText.h>
#include "CDRVRArray.h"
#include "CDRVRTable.h"

static Boolean ByKind( CView *scrollPane, void* targetID)
	{
	return member(scrollPane, CScrollPane);
	}

static Boolean ByKind_set_text( CView *pane, void* targetID)
	{
	if (member(pane, CIntegerText))
		{
		long	**value = (long **)targetID;
		((CIntegerText *)pane)->SetIntValue(**value);
		((CIntegerText *)pane)->Specify( kNotEditable, kNotSelectable, kNotStylable);
		(*value)++;
		}
	return false;
	}

void CDRVRDirector::IDRVRDirector( short DRVRid, CDirectorOwner *aSupervisor)
	{
	Handle Data = GetResource( 'DRVR', DRVRid);
	Str255	rName;
	ResType	rType;
	FailNILRes(Data);
	GetResInfo(Data,&DRVRid,&rType,rName);
	rName[1] = rName[0]-1;	/* get rid of initial null */
	NewDocument(Data, aSupervisor, rName+1);
	}

void CDRVRDirector::NewDocument( Handle Data, CDirectorOwner *aSupervisor, Str255 name)
	{
	CScrollPane *scrollPane;

	CDLOGDirector::IDLOGDirector( 10000, aSupervisor);
	
	itsData = Data;	
	itsWindow->SetTitle(name);
	scrollPane = (CScrollPane *)itsWindow->MatchView( ByKind, 0);

	if (scrollPane)
		{
		CPaneBorder *listBorder;
		Rect	margin;
		Cell	aCell;	
		TextInfoRec	textInfo;
		textInfo.fontNumber = monaco;
		textInfo.theSize = 9;
		textInfo.theStyle = 0;
		textInfo.theMode = srcOr;		  
	
		itsStringTable = new( CDRVRTable);
		itsStringTable->IArrayPane( scrollPane, itsWindow, 0, 0, 0, 0,
			sizELASTIC, sizELASTIC);
		itsStringTable->FitToEnclosure( TRUE, TRUE);
		itsStringTable->SetDrawActiveBorder( TRUE);
		((CTextEnvirons *)(itsStringTable->itsEnvironment))->SetTextInfo( &textInfo);		
		itsStringTable->SetID( 10);

		listBorder = new( CPaneBorder);
		listBorder->IPaneBorder( kBorderFrame);
		  
		itsStringTable->SetBorder( listBorder);
				
		itsStringTable->SetSelectionFlags( selOnlyOne);
		
		scrollPane->InstallPanorama( itsStringTable);
		
		itsStrings = new( CDRVRArray);
		itsStrings->IResHandle( itsData );
		itsStrings->Sort(TRUE);

		itsStringTable->SetArray( itsStrings, FALSE);
		
		SetCell( aCell, 0, 0);
		itsStringTable->SelectCell( aCell, FALSE, FALSE);

		}
		
	if (itsStrings)
		{
		long	temp[10];
		long	*ptr = temp;
		*ptr++ = itsStrings->execp->a_text;
		*ptr++ = itsStrings->execp->a_data;
		*ptr++ = itsStrings->execp->a_bss;
		*ptr++ = itsStrings->execp->a_syms/sizeof (struct nlist);
		*ptr++ = itsStrings->execp->a_entry;
		*ptr++ = itsStrings->execp->a_trsize;
		*ptr++ = itsStrings->execp->a_drsize;
		*ptr++ = temp[0]+temp[1]+temp[2]+
				 temp[3]*sizeof (struct nlist)+
				 temp[5]+temp[6];
		ptr = temp;
		itsWindow->MatchView( ByKind_set_text, &ptr);
		}
	}	/* CDRVRDirector::IDRVRDirector */


void CDRVRDirector::Dispose( void)
{
	itsStrings = 0;
	inherited::Dispose();
}

