/******************************************************************************
 CResTypePane.c

	A subclass of CArrayPane that displays a list of resource types.
	The resource type list is stored in an array of structs of type 
	tResTypeInfo.
	
	SUPERCLASS = CArrayPane
	
	Copyright  1991 Symantec Corporation. All rights reserved.
	

 ******************************************************************************/

#include "CResTypePane.h"
#include "ResourceStructs.h"
#include "CArray.h"

/******************************************************************************
 IResTypePane
 
 	Initialization method for CResTypePane.
******************************************************************************/

void CResTypePane::IResTypePane( CView *anEnclosure, CBureaucrat *aSupervisor,
						short aWidth, short aHeight,
						short aHEncl, short aVEncl,
						SizingOption aHSizing, SizingOption aVSizing)
{
	CArrayPane::IArrayPane( anEnclosure, aSupervisor, aWidth, aHeight,
			aHEncl, aVEncl, aHSizing, aVSizing);
			
}
							
/******************************************************************************
 DrawCell
 
 	Draws a single cell. This method retrieves the tResTypeInfo struct for
 	the current cell and draws it.
 	
******************************************************************************/

void CResTypePane::DrawCell( Cell theCell, Rect *cellRect)
{
	tResTypeInfo	resType;
	
	if (!itsArray) return;
	
	itsArray->GetItem( &resType, theCell.v + 1);
	
	MoveTo( cellRect->left + indent.h, cellRect->top + indent.v);
	if (resType.editable)
		TextFace( bold);
	DrawText( &resType.type, 0, sizeof(ResType));
	TextFace( 0);
}